#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <unistd.h>
#include "libldetect.h"


int verboze = 0;
int full_probe = 0;

void usage(void)
{
	printf("usage: uhupcilst [-v] [-f]\n");
	exit(0);
}

void pci_printit(struct pciusb_entries entries)
{
	int x;
	int i;
	char *argv[3] = { "modprobe" };
	for (i = 0; i < entries.nb; i++) {
	    argv[1] = entries.entries[i].module;
		if (argv[1]) {
		    if (fork()) {
				wait(&x);
		    } else {
				if (getenv("UHU_DEBUG"))
					printf("Loading: [%s]\n", argv[1]);
				execve("/sbin/modprobe", argv, NULL);
		    }
		}
	}
}

int main(int argc, char **argv)
{
	char **ptr = argv;
	while (ptr && *ptr) {
		if (!strcmp(*ptr, "-h") || !strcmp(*ptr, "--help"))
			usage();
		if (!strcmp(*ptr, "-v")) {
			verboze = 1;
			full_probe = 1;
		}
		if (!strcmp(*ptr, "-f"))
			full_probe = 1;
		ptr++;
	}
	{
		struct pciusb_entries entries = pci_probe(full_probe);
		pci_printit(entries);
		pciusb_free(entries);
	}
	exit(0);
}
